/*
Copyright 2019 Rancher Labs.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by main. DO NOT EDIT.

package v1

import (
	internalinterfaces "github.com/rancher/rio/pkg/generated/informers/externalversions/internalinterfaces"
)

// Interface provides access to all the informers in this group version.
type Interface interface {
	// ClusterDomains returns a ClusterDomainInformer.
	ClusterDomains() ClusterDomainInformer
	// PublicDomains returns a PublicDomainInformer.
	PublicDomains() PublicDomainInformer
	// RioInfos returns a RioInfoInformer.
	RioInfos() RioInfoInformer
	// SystemStacks returns a SystemStackInformer.
	SystemStacks() SystemStackInformer
}

type version struct {
	factory          internalinterfaces.SharedInformerFactory
	namespace        string
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// New returns a new Interface.
func New(f internalinterfaces.SharedInformerFactory, namespace string, tweakListOptions internalinterfaces.TweakListOptionsFunc) Interface {
	return &version{factory: f, namespace: namespace, tweakListOptions: tweakListOptions}
}

// ClusterDomains returns a ClusterDomainInformer.
func (v *version) ClusterDomains() ClusterDomainInformer {
	return &clusterDomainInformer{factory: v.factory, tweakListOptions: v.tweakListOptions}
}

// PublicDomains returns a PublicDomainInformer.
func (v *version) PublicDomains() PublicDomainInformer {
	return &publicDomainInformer{factory: v.factory, tweakListOptions: v.tweakListOptions}
}

// RioInfos returns a RioInfoInformer.
func (v *version) RioInfos() RioInfoInformer {
	return &rioInfoInformer{factory: v.factory, tweakListOptions: v.tweakListOptions}
}

// SystemStacks returns a SystemStackInformer.
func (v *version) SystemStacks() SystemStackInformer {
	return &systemStackInformer{factory: v.factory, tweakListOptions: v.tweakListOptions}
}
