/*
Copyright 2019 Rancher Labs.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by main. DO NOT EDIT.

package v1

import (
	v1 "github.com/rancher/rio/pkg/apis/admin.rio.cattle.io/v1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// RioInfoLister helps list RioInfos.
type RioInfoLister interface {
	// List lists all RioInfos in the indexer.
	List(selector labels.Selector) (ret []*v1.RioInfo, err error)
	// Get retrieves the RioInfo from the index for a given name.
	Get(name string) (*v1.RioInfo, error)
	RioInfoListerExpansion
}

// rioInfoLister implements the RioInfoLister interface.
type rioInfoLister struct {
	indexer cache.Indexer
}

// NewRioInfoLister returns a new RioInfoLister.
func NewRioInfoLister(indexer cache.Indexer) RioInfoLister {
	return &rioInfoLister{indexer: indexer}
}

// List lists all RioInfos in the indexer.
func (s *rioInfoLister) List(selector labels.Selector) (ret []*v1.RioInfo, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.RioInfo))
	})
	return ret, err
}

// Get retrieves the RioInfo from the index for a given name.
func (s *rioInfoLister) Get(name string) (*v1.RioInfo, error) {
	obj, exists, err := s.indexer.GetByKey(name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1.Resource("rioinfo"), name)
	}
	return obj.(*v1.RioInfo), nil
}
