// Code generated by solo-kit. DO NOT EDIT.

package v1

import (
	"github.com/solo-io/go-utils/contextutils"
	"github.com/solo-io/solo-kit/pkg/api/v1/clients"
	"github.com/solo-io/solo-kit/pkg/api/v1/reconcile"
	"github.com/solo-io/solo-kit/pkg/api/v1/resources"
)

// Option to copy anything from the original to the desired before writing. Return value of false means don't update
type TransitionGatewayFunc func(original, desired *Gateway) (bool, error)

type GatewayReconciler interface {
	Reconcile(namespace string, desiredResources GatewayList, transition TransitionGatewayFunc, opts clients.ListOpts) error
}

func gatewaysToResources(list GatewayList) resources.ResourceList {
	var resourceList resources.ResourceList
	for _, gateway := range list {
		resourceList = append(resourceList, gateway)
	}
	return resourceList
}

func NewGatewayReconciler(client GatewayClient) GatewayReconciler {
	return &gatewayReconciler{
		base: reconcile.NewReconciler(client.BaseClient()),
	}
}

type gatewayReconciler struct {
	base reconcile.Reconciler
}

func (r *gatewayReconciler) Reconcile(namespace string, desiredResources GatewayList, transition TransitionGatewayFunc, opts clients.ListOpts) error {
	opts = opts.WithDefaults()
	opts.Ctx = contextutils.WithLogger(opts.Ctx, "gateway_reconciler")
	var transitionResources reconcile.TransitionResourcesFunc
	if transition != nil {
		transitionResources = func(original, desired resources.Resource) (bool, error) {
			return transition(original.(*Gateway), desired.(*Gateway))
		}
	}
	return r.base.Reconcile(namespace, gatewaysToResources(desiredResources), transitionResources, opts)
}
