// Code generated by solo-kit. DO NOT EDIT.

package v1

import (
	"github.com/solo-io/go-utils/contextutils"
	"github.com/solo-io/solo-kit/pkg/api/v1/clients"
	"github.com/solo-io/solo-kit/pkg/api/v1/reconcile"
	"github.com/solo-io/solo-kit/pkg/api/v1/resources"
)

// Option to copy anything from the original to the desired before writing. Return value of false means don't update
type TransitionAuthConfigFunc func(original, desired *AuthConfig) (bool, error)

type AuthConfigReconciler interface {
	Reconcile(namespace string, desiredResources AuthConfigList, transition TransitionAuthConfigFunc, opts clients.ListOpts) error
}

func authConfigsToResources(list AuthConfigList) resources.ResourceList {
	var resourceList resources.ResourceList
	for _, authConfig := range list {
		resourceList = append(resourceList, authConfig)
	}
	return resourceList
}

func NewAuthConfigReconciler(client AuthConfigClient) AuthConfigReconciler {
	return &authConfigReconciler{
		base: reconcile.NewReconciler(client.BaseClient()),
	}
}

type authConfigReconciler struct {
	base reconcile.Reconciler
}

func (r *authConfigReconciler) Reconcile(namespace string, desiredResources AuthConfigList, transition TransitionAuthConfigFunc, opts clients.ListOpts) error {
	opts = opts.WithDefaults()
	opts.Ctx = contextutils.WithLogger(opts.Ctx, "authConfig_reconciler")
	var transitionResources reconcile.TransitionResourcesFunc
	if transition != nil {
		transitionResources = func(original, desired resources.Resource) (bool, error) {
			return transition(original.(*AuthConfig), desired.(*AuthConfig))
		}
	}
	return r.base.Reconcile(namespace, authConfigsToResources(desiredResources), transitionResources, opts)
}
