// Code generated by solo-kit. DO NOT EDIT.

package kubernetes

import (
	"github.com/solo-io/go-utils/contextutils"
	"github.com/solo-io/solo-kit/pkg/api/v1/clients"
	"github.com/solo-io/solo-kit/pkg/api/v1/reconcile"
	"github.com/solo-io/solo-kit/pkg/api/v1/resources"
)

// Option to copy anything from the original to the desired before writing. Return value of false means don't update
type TransitionPodFunc func(original, desired *Pod) (bool, error)

type PodReconciler interface {
	Reconcile(namespace string, desiredResources PodList, transition TransitionPodFunc, opts clients.ListOpts) error
}

func podsToResources(list PodList) resources.ResourceList {
	var resourceList resources.ResourceList
	for _, pod := range list {
		resourceList = append(resourceList, pod)
	}
	return resourceList
}

func NewPodReconciler(client PodClient) PodReconciler {
	return &podReconciler{
		base: reconcile.NewReconciler(client.BaseClient()),
	}
}

type podReconciler struct {
	base reconcile.Reconciler
}

func (r *podReconciler) Reconcile(namespace string, desiredResources PodList, transition TransitionPodFunc, opts clients.ListOpts) error {
	opts = opts.WithDefaults()
	opts.Ctx = contextutils.WithLogger(opts.Ctx, "pod_reconciler")
	var transitionResources reconcile.TransitionResourcesFunc
	if transition != nil {
		transitionResources = func(original, desired resources.Resource) (bool, error) {
			return transition(original.(*Pod), desired.(*Pod))
		}
	}
	return r.base.Reconcile(namespace, podsToResources(desiredResources), transitionResources, opts)
}
